# n s l o o k u p    v 1 . 0		                                        #
# by:   gozzip@Undernet                                                         #                                   
# mail: 2-lazy@gmx.net                                                          #                     
# ----                                                                          #  
# This script lets you resolve IPs and hostnames. This is done via eggdrop's    #
# own dns module. The script has a tiny-tiny AI - but nothing to brag about.	#
# If you find use of this script, you are probably a little bored :o)		#
#										#
# Triggers:									#
# !nslookup <host|IP|nick>							#
# !dns <host|IP|nick>								#
#										#
# happy surfin'									#
#################################################################################

## C O N F I G :

#should the script work on all channels? 0:off, 1:on
set ns(all) 1

#channels this should work on if ns(all) is off?
set ns(chans) "#mychan #yourchan #ourchan"



## S C R I P T :

#redefine the channel-var
set ns(chans) [string tolower $ns(chans)]

#binds
bind pub - "!dns" nslookup
bind pub - "!nslookup" nslookup

#the lookup
proc nslookup {nick host hand chan args} {

  #load some global vars
  global ns
  
  #set some variables
  set query  [lindex $args 0]
  set query2 [string tolower $query]
  set chan   [string tolower $chan]
  
  #return if this is an invalid channel
  if {!$ns(all) && [lsearch -exact $ns(chans) $chan] == -1} {return 0}
    
  #return som errors
  if {$query == ""} {puthelp "notice $nick :Usage: !dns <host|nick>"; return 0}
    
  #check if we were asked to lookup a nick
  set isnick [onchan $query2]
  
  #check if we got an ip
  regsub -all -- \[0-9\] $query2 "" temp
  if {$temp == "..."} {set isip 1} {set isip 0}
  
  #check if we got a host
  set ishost [regexp ^\[0-9a-z.-\]+$ $query2]
 
  #if we didnt get a match in any of our checks, return an error
  if {!$isnick && !$isip && !$ishost} {
     puthelp "notice $nick :You seem to have specified some invalid information. Make sure to specify a valid host, IP or nickname."
     return 0
  }
  
  #do the thing we were asked todo
  if {$isnick} {
     set query2 [getchanhost $nick]
     set query2 [split $query2 @]
     set query2 [lindex $query2 1]
     dnslookup $query2 returnlookup $query nick $chan $nick
     return 0
  } elseif {$isip} {
     dnslookup $query2 returnlookup $query ip $chan $nick
     return 0
  } elseif {$ishost} {
     dnslookup $query2 returnlookup $query host $chan $nick
     return 0
  }
  
  #if we for some reason have not returned now, lets complain! (if this happens, something weird is going on)
  puthelp "notice $nick :There seems to be a problem with my programming, please notify my admin!"
  
} ;#end proc



#the return
proc returnlookup {ip host status query askedtodo chan requestor} {

  #load in the botnick
  global botnick

  #check that the host is not an IP (which it sometimes is on IRC)
  regsub -all -- \[0-9\] $host "" temp
  if {$temp == "..."} {set hostip 1} {set hostip 0}


  ## If the nick requested was the botnick or the requestor :

    #if we were or were not able to resolve the query - and the nick was the botnick;
    if {$askedtodo == "nick" && $status && !$hostip && [string tolower $query] == [string tolower $botnick]} {
       puthelp "privmsg $chan :My host is $host, bound to $ip"
       return 0
    } elseif {$askedtodo == "nick" && !$status && !$hostip && [string tolower $query] == [string tolower $botnick]} {
       puthelp "privmsg $chan :I don't know my IP, but my host is $host"
       return 0
    } elseif {$askedtodo == "nick" && !$status && $hostip && [string tolower $query] == [string tolower $botnick]} {
       puthelp "privmsg $chan :I don't know my host, but my IP is $host"
       return 0
    } 

    #if we were or were not able to resolve the query - and the nick was the nick who called us;
    if {$askedtodo == "nick" && $status && !$hostip && [string tolower $query] == [string tolower $requestor]} {
       puthelp "privmsg $chan :Your host is $host, bound to $ip"
       return 0
    } elseif {$askedtodo == "nick" && !$status && $hostip && [string tolower $query] == [string tolower $requestor]} {
       puthelp "privmsg $chan :I was not able to resolve your host, but your IP is $ip"
       return 0
    } elseif {$askedtodo == "nick" && !$status && !$hostip && [string tolower $query] == [string tolower $requestor]} {
       puthelp "privmsg $chan :I was not able to resolve your IP, but your host is $host"
       return 0
    }


  ## In all other cases :

    #if we werent able to evaluate the query
    if {!$status && ($askedtodo == "ip" || $askedtodo == "host")} {puthelp "privmsg $chan :I was not able to resolve $query"; return 0}
    if {!$status && $askedtodo == "nick" && !$hostip} {puthelp "privmsg $chan :I was not able to resolve $query's IP, but his host is $host"; return 0}
    if {!$status && $askedtodo == "nick" && $hostip} {puthelp "privmsg $chan :I was not able to resolve $query's host, but his IP is $host"; return 0}

    #if we were able to resolve the query, display it (woohoo)
    if {$askedtodo == "ip"} {puthelp "privmsg $chan :$query resolved to $host"} \
    elseif {$askedtodo == "host"} {puthelp "privmsg $chan :$query resolved to $ip"} \
    elseif {$askedtodo == "nick"} {puthelp "privmsg $chan :$query's host resolved to $host, bound to $ip"}
  
  
} ;#end proc



#give me some credits
putlog "nslookup v1.0 by gozzip loaded"
